Package com.sas.metadata.remote

# Interface ITFilter

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface ITFilter extends SecondaryType
A filter string is used to include or exclude content going to a specific subscriber. It can be used to filter entries in a package, or the entire package.

Attributes of ITFilter are:

- `FilterString`
- `FilterRole`

Associations of ITFilter are:

- `FilterSubscriber`

## Usage

To create an instance of this ITFilter, use the `factory` create methods.
Example: create a ITFilter with name "ITFilter_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     ITFilter myObject = (ITFilter) factory.createComplexMetadataObject(objectStore, "ITFilter_Object", MetadataObjects.ITFILTER, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_FILTERSUBSCRIBER_NAME`
  Constant used for the name of the FilterSubscriber association.
  `static final String`
  `ATTRIBUTE_FILTERROLE_NAME`
  Constant used for the name of the FilterRole attribute.
  `static final String`
  `ATTRIBUTE_FILTERSTRING_NAME`
  Constant used for the name of the FilterString attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getFilterRole()`
  Gets the `String` value of `FilterRole`
  `int`
  `getFilterRoleMaxLength()`
  Gets the maximum length of `FilterRole`
  `int`
  `getFilterRoleState()`
  Gets the Metadata State of `FilterRole`
  `String`
  `getFilterString()`
  Gets the `String` value of `FilterString`
  `int`
  `getFilterStringMaxLength()`
  Gets the maximum length of `FilterString`
  `int`
  `getFilterStringState()`
  Gets the Metadata State of `FilterString`
  `ITContentSubscriber`
  `getFilterSubscriber()`
  Gets the `ITContentSubscriber` for `FilterSubscriber`
  `AssociationList`
  `getFilterSubscribers()`
  Gets the AssociationList of `FilterSubscribers`
  `AssociationList`
  `getFilterSubscribers(boolean fGoToServer)`
  Gets the Associationlist of `FilterSubscribers`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `FilterSubscriber`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setFilterRole(String inFilterRole)`
  Sets the `FilterRole` value and sets the state to MetadataState.LOCAL.
  `void`
  `setFilterRole(String inFilterRole, int state)`
  Sets the `FilterRole` Metadata State.
  `void`
  `setFilterRoleState(int state)`
  Sets the Metadata State of `FilterRole`.
  `void`
  `setFilterString(String inFilterString)`
  Sets the `FilterString` value and sets the state to MetadataState.LOCAL.
  `void`
  `setFilterString(String inFilterString, int state)`
  Sets the `FilterString` Metadata State.
  `void`
  `setFilterStringState(int state)`
  Sets the Metadata State of `FilterString`.
  `void`
  `setFilterSubscriber(ITContentSubscriber inObject)`
  Sets the `FilterSubscribers` list 0th element to be `inObject`.
  `void`
  `setFilterSubscribers(AssociationList list)`
  Sets the `FilterSubscribers` list to be `list`.
  `void`
  `setFilterSubscribers(AssociationList list, int state)`
  Sets the `FilterSubscribers` list to be `list`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_FILTERSTRING_NAME

    static final String ATTRIBUTE_FILTERSTRING_NAME
    Constant used for the name of the FilterString attribute.

    FilterString: Filter string to control content delivered to specific subscriber identities.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_FILTERROLE_NAME

    static final String ATTRIBUTE_FILTERROLE_NAME
    Constant used for the name of the FilterRole attribute.

    FilterRole: The role this filter plays in the subscriber definition. Valid values are: NameValueInclusionFilter NameValueExclusionFilter EntryInclusionFilter EntryExclusionFilter FileMIMETypeInclusionFilter FileMIMETypeExclusionFilter

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_FILTERSUBSCRIBER_NAME

    static final String ASSOCIATION_FILTERSUBSCRIBER_NAME
    Constant used for the name of the FilterSubscriber association.

    FilterSubscriber: The subscriber that uses this content filter.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `FilterSubscriber`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterString

    String getFilterString() throws RemoteException
    Gets the `String` value of `FilterString`
    Returns:
      The `FilterString`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterStringState

    int getFilterStringState() throws RemoteException
    Gets the Metadata State of `FilterString`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterStringMaxLength

    int getFilterStringMaxLength() throws RemoteException
    Gets the maximum length of `FilterString`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterRole

    String getFilterRole() throws RemoteException
    Gets the `String` value of `FilterRole`
    Returns:
      The `FilterRole`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterRoleState

    int getFilterRoleState() throws RemoteException
    Gets the Metadata State of `FilterRole`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterRoleMaxLength

    int getFilterRoleMaxLength() throws RemoteException
    Gets the maximum length of `FilterRole`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFilterSubscribers

    AssociationList getFilterSubscribers() throws RemoteException, MdException
    Gets the AssociationList of `FilterSubscribers`
    Returns:
      Returns the AssociationList of `FilterSubscribers` which can be of type:
      ITContentSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getFilterSubscriber

    ITContentSubscriber getFilterSubscriber() throws RemoteException, MdException
    Gets the `ITContentSubscriber` for `FilterSubscriber`
    Returns:
      The `ITContentSubscriber` ( `null` if not set) of `FilterSubscriber`which can be of type:
      ITContentSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getFilterSubscribers

    AssociationList getFilterSubscribers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `FilterSubscribers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `FilterSubscribers` which can be of type:
      ITContentSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setFilterString

    void setFilterString(String inFilterString) throws RemoteException
    Sets the `FilterString` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inFilterString` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterString

    void setFilterString(String inFilterString, int state) throws RemoteException
    Sets the `FilterString` Metadata State.
    Parameters:
      `inFilterString` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterStringState

    void setFilterStringState(int state) throws RemoteException
    Sets the Metadata State of `FilterString`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterRole

    void setFilterRole(String inFilterRole) throws RemoteException
    Sets the `FilterRole` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inFilterRole` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterRole

    void setFilterRole(String inFilterRole, int state) throws RemoteException
    Sets the `FilterRole` Metadata State.
    Parameters:
      `inFilterRole` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterRoleState

    void setFilterRoleState(int state) throws RemoteException
    Sets the Metadata State of `FilterRole`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterSubscribers

    void setFilterSubscribers(AssociationList list) throws RemoteException
    Sets the `FilterSubscribers` list to be `list`. Object of which can be of type:
    ITContentSubscriber
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterSubscribers

    void setFilterSubscribers(AssociationList list, int state) throws RemoteException
    Sets the `FilterSubscribers` list to be `list`. Object of which can be of type:
    ITContentSubscriber
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFilterSubscriber

    void setFilterSubscriber(ITContentSubscriber inObject) throws RemoteException
    Sets the `FilterSubscribers` list 0th element to be `inObject`.
    Parameters:
      `inObject` - ITContentSubscriber
    Throws:
      `RemoteException` - If error communicating with remote object.